Index: cpukit/libblock/src/bdbuf.c
===================================================================
--- cpukit/libblock/src/bdbuf.c	(revision f14a21df691328cefa1464fc5ef13c0584bbfaf3)
+++ cpukit/libblock/src/bdbuf.c	(revision 0d15414ed6c144f7f7e4ce63476b3eb9b94acceb)
@@ -2180,5 +2488,5 @@
    * is already part of the buffer structure.
    */
-  write_req =
+  rtems_blkdev_request* write_req =
     malloc (sizeof (rtems_blkdev_request) +
             (rtems_bdbuf_configuration.max_write_blocks *
@@ -2193,4 +2501,140 @@
   write_req->io_task = rtems_task_self ();
 
+  return write_req;
+}
+
+/**
+ * The swapout worker thread body.
+ *
+ * @param arg A pointer to the worker thread's private data.
+ * @return rtems_task Not used.
+ */
+static rtems_task
+rtems_bdbuf_swapout_worker_task (rtems_task_argument arg)
+{
+  rtems_bdbuf_swapout_worker* worker = (rtems_bdbuf_swapout_worker*) arg;
+
+  while (worker->enabled)
+  {
+    rtems_event_set   out;
+    rtems_status_code sc;
+    
+    sc = rtems_event_receive (RTEMS_BDBUF_SWAPOUT_SYNC,
+                              RTEMS_EVENT_ALL | RTEMS_WAIT,
+                              RTEMS_NO_TIMEOUT,
+                              &out);
+
+    if (sc != RTEMS_SUCCESSFUL)
+      rtems_fatal_error_occurred (BLKDEV_FATAL_BDBUF_SWAPOUT_RE);
+
+    rtems_bdbuf_swapout_write (&worker->transfer);
+
+    rtems_bdbuf_lock_cache ();
+
+    rtems_chain_initialize_empty (&worker->transfer.bds);
+    worker->transfer.dev = -1;
+
+    rtems_chain_append (&bdbuf_cache.swapout_workers, &worker->link);
+    
+    rtems_bdbuf_unlock_cache ();
+  }
+
+  free (worker->transfer.write_req);
+  free (worker);
+
+  rtems_task_delete (RTEMS_SELF);
+}
+
+/**
+ * Open the swapout worker threads.
+ */
+static void
+rtems_bdbuf_swapout_workers_open (void)
+{
+  rtems_status_code sc;
+  int               w;
+  
+  rtems_bdbuf_lock_cache ();
+  
+  for (w = 0; w < rtems_bdbuf_configuration.swapout_workers; w++)
+  {
+    rtems_bdbuf_swapout_worker* worker;
+
+    worker = malloc (sizeof (rtems_bdbuf_swapout_worker));
+    if (!worker)
+      rtems_fatal_error_occurred (RTEMS_BLKDEV_FATAL_BDBUF_SO_NOMEM);
+
+    rtems_chain_append (&bdbuf_cache.swapout_workers, &worker->link);
+    worker->enabled = true;
+    worker->transfer.write_req = rtems_bdbuf_swapout_writereq_alloc ();
+    
+    rtems_chain_initialize_empty (&worker->transfer.bds);
+    worker->transfer.dev = -1;
+
+    sc = rtems_task_create (rtems_build_name('B', 'D', 'o', 'a' + w),
+                            (rtems_bdbuf_configuration.swapout_priority ?
+                             rtems_bdbuf_configuration.swapout_priority :
+                             RTEMS_BDBUF_SWAPOUT_TASK_PRIORITY_DEFAULT),
+                            SWAPOUT_TASK_STACK_SIZE,
+                            RTEMS_PREEMPT | RTEMS_NO_TIMESLICE | RTEMS_NO_ASR,
+                            RTEMS_LOCAL | RTEMS_NO_FLOATING_POINT,
+                            &worker->id);
+    if (sc != RTEMS_SUCCESSFUL)
+      rtems_fatal_error_occurred (RTEMS_BLKDEV_FATAL_BDBUF_SO_WK_CREATE);
+
+    sc = rtems_task_start (worker->id,
+                           rtems_bdbuf_swapout_worker_task,
+                           (rtems_task_argument) worker);
+    if (sc != RTEMS_SUCCESSFUL)
+      rtems_fatal_error_occurred (RTEMS_BLKDEV_FATAL_BDBUF_SO_WK_START);
+  }
+  
+  rtems_bdbuf_unlock_cache ();
+}
+
+/**
+ * Close the swapout worker threads.
+ */
+static void
+rtems_bdbuf_swapout_workers_close (void)
+{
+  rtems_chain_node* node;
+  
+  rtems_bdbuf_lock_cache ();
+  
+  node = rtems_chain_first (&bdbuf_cache.swapout_workers);
+  while (!rtems_chain_is_tail (&bdbuf_cache.swapout_workers, node))
+  {
+    rtems_bdbuf_swapout_worker* worker = (rtems_bdbuf_swapout_worker*) node;
+    worker->enabled = false;
+    rtems_event_send (worker->id, RTEMS_BDBUF_SWAPOUT_SYNC);
+    node = rtems_chain_next (node);
+  }
+  
+  rtems_bdbuf_unlock_cache ();
+}
+
+/**
+ * Body of task which takes care on flushing modified buffers to the disk.
+ *
+ * @param arg A pointer to the global cache data. Use the global variable and
+ *            not this.
+ * @return rtems_task Not used.
+ */
+static rtems_task
+rtems_bdbuf_swapout_task (rtems_task_argument arg)
+{
+  rtems_bdbuf_swapout_transfer transfer;
+  uint32_t                     period_in_ticks;
+  const uint32_t               period_in_msecs = bdbuf_config.swapout_period;;
+  uint32_t                     timer_delta;
+
+  transfer.write_req = rtems_bdbuf_swapout_writereq_alloc ();
+  rtems_chain_initialize_empty (&transfer.bds);
+  transfer.dev = -1;
+
+  /*
+   * Localise the period.
+   */
   period_in_ticks = RTEMS_MICROSECONDS_TO_TICKS (period_in_msecs * 1000);
 
@@ -2200,7 +2644,13 @@
   timer_delta = period_in_msecs;
 
-  while (context->swapout_enabled)
-  {
-    rtems_event_set out;
+  /*
+   * Create the worker threads.
+   */
+  rtems_bdbuf_swapout_workers_open ();
+  
+  while (bdbuf_cache.swapout_enabled)
+  {
+    rtems_event_set   out;
+    rtems_status_code sc;
 
     /*
@@ -2211,5 +2661,5 @@
     /*
      * If we write buffers to any disk perform a check again. We only write a
-     * single device at a time and a pool may have more than one devices
+     * single device at a time and the cache may have more than one device's
      * buffers modified waiting to be written.
      */
@@ -2218,24 +2668,18 @@
     do
     {
-      rtems_bdpool_id pid;
-    
       transfered_buffers = false;
 
       /*
-       * Loop over each pool extacting all the buffers we find for a specific
-       * device. The device is the first one we find on a modified list of a
-       * pool. Process the sync queue of buffers first.
+       * Extact all the buffers we find for a specific device. The device is
+       * the first one we find on a modified list. Process the sync queue of
+       * buffers first.
        */
-      for (pid = 0; pid < context->npools; pid++)
+      if (rtems_bdbuf_swapout_processing (timer_delta,
+                                          update_timers,
+                                          &transfer))
       {
-        if (rtems_bdbuf_swapout_pool_processing (pid,
-                                                 timer_delta,
-                                                 update_timers,
-                                                 write_req))
-        {
-          transfered_buffers = true;
-        }
+        transfered_buffers = true;
       }
-
+      
       /*
        * Only update the timers once.
@@ -2254,66 +2698,9 @@
   }
 
-  free (write_req);
+  rtems_bdbuf_swapout_workers_close ();
+  
+  free (transfer.write_req);
 
   rtems_task_delete (RTEMS_SELF);
 }
 
-rtems_status_code
-rtems_bdbuf_find_pool (uint32_t block_size, rtems_bdpool_id *pool)
-{
-  rtems_bdbuf_pool* p;
-  rtems_bdpool_id   i;
-  rtems_bdpool_id   curid = -1;
-  bool              found = false;
-  uint32_t          cursize = UINT_MAX;
-  int               j;
-
-  for (j = block_size; (j != 0) && ((j & 1) == 0); j >>= 1);
-  if (j != 1)
-    return RTEMS_INVALID_SIZE;
-
-  for (i = 0; i < rtems_bdbuf_ctx.npools; i++)
-  {
-    p = rtems_bdbuf_get_pool (i);
-    if ((p->blksize >= block_size) &&
-        (p->blksize < cursize))
-    {
-      curid = i;
-      cursize = p->blksize;
-      found = true;
-    }
-  }
-
-  if (found)
-  {
-    if (pool != NULL)
-      *pool = curid;
-    return RTEMS_SUCCESSFUL;
-  }
-  else
-  {
-    return RTEMS_NOT_DEFINED;
-  }
-}
-
-rtems_status_code rtems_bdbuf_get_pool_info(
-  rtems_bdpool_id pool,
-  uint32_t *block_size,
-  uint32_t *blocks
-)
-{
-  if (pool >= rtems_bdbuf_ctx.npools)
-    return RTEMS_INVALID_NUMBER;
-
-  if (block_size != NULL)
-  {
-    *block_size = rtems_bdbuf_ctx.pool[pool].blksize;
-  }
-
-  if (blocks != NULL)
-  {
-    *blocks = rtems_bdbuf_ctx.pool[pool].nblks;
-  }
-
-  return RTEMS_SUCCESSFUL;
-}
Index: cpukit/libblock/src/blkdev.c
===================================================================
--- cpukit/libblock/src/blkdev.c	(revision f14a21df691328cefa1464fc5ef13c0584bbfaf3)
+++ cpukit/libblock/src/blkdev.c	(revision 0d15414ed6c144f7f7e4ce63476b3eb9b94acceb)
@@ -38,5 +38,4 @@
 {
     rtems_libio_rw_args_t *args = arg;
-    int block_size_log2;
     int block_size;
     char         *buf;
@@ -52,5 +51,4 @@
         return RTEMS_INVALID_NUMBER;
 
-    block_size_log2 = dd->block_size_log2;
     block_size = dd->block_size;
 
@@ -59,6 +57,6 @@
     args->bytes_moved = 0;
 
-    block = args->offset >> block_size_log2;
-    blkofs = args->offset & (block_size - 1);
+    block = args->offset / block_size;
+    blkofs = args->offset % block_size;
 
     while (count > 0)
@@ -98,5 +96,4 @@
 {
     rtems_libio_rw_args_t *args = arg;
-    int           block_size_log2;
     uint32_t      block_size;
     char         *buf;
@@ -113,5 +110,4 @@
         return RTEMS_INVALID_NUMBER;
 
-    block_size_log2 = dd->block_size_log2;
     block_size = dd->block_size;
 
@@ -120,6 +116,6 @@
     args->bytes_moved = 0;
 
-    block = args->offset >> block_size_log2;
-    blkofs = args->offset & (block_size - 1);
+    block = args->offset / block_size;
+    blkofs = args->offset % block_size;
 
     while (count > 0)
Index: cpukit/libblock/src/diskdevs.c
===================================================================
--- cpukit/libblock/src/diskdevs.c	(revision f14a21df691328cefa1464fc5ef13c0584bbfaf3)
+++ cpukit/libblock/src/diskdevs.c	(revision 0d15414ed6c144f7f7e4ce63476b3eb9b94acceb)
@@ -227,18 +227,10 @@
 )
 {
-    int bs_log2;
-    int i;
     rtems_disk_device *dd;
     rtems_status_code rc;
-    rtems_bdpool_id pool;
     rtems_device_major_number major;
     rtems_device_minor_number minor;
 
     rtems_filesystem_split_dev_t (dev, major, minor);
-
-
-    for (bs_log2 = 0, i = block_size; (i & 1) == 0; i >>= 1, bs_log2++);
-    if ((bs_log2 < 9) || (i != 1)) /* block size < 512 or not power of 2 */
-        return RTEMS_INVALID_NUMBER;
 
     rc = rtems_semaphore_obtain(diskdevs_mutex, RTEMS_WAIT, RTEMS_NO_TIMEOUT);
@@ -247,12 +239,4 @@
     diskdevs_protected = true;
 
-    rc = rtems_bdbuf_find_pool(block_size, &pool);
-    if (rc != RTEMS_SUCCESSFUL)
-    {
-        diskdevs_protected = false;
-        rtems_semaphore_release(diskdevs_mutex);
-        return rc;
-    }
-
     rc = create_disk(dev, name, &dd);
     if (rc != RTEMS_SUCCESSFUL)
@@ -267,8 +251,6 @@
     dd->start = 0;
     dd->size = disk_size;
-    dd->block_size = block_size;
-    dd->block_size_log2 = bs_log2;
+    dd->block_size = dd->media_block_size = block_size;
     dd->ioctl = handler;
-    dd->pool = pool;
 
     rc = rtems_io_register_name(name, major, minor);
@@ -334,5 +316,4 @@
   dd->size = size;
   dd->block_size = pdd->block_size;
-  dd->block_size_log2 = pdd->block_size_log2;
   dd->ioctl = pdd->ioctl;
 
@@ -556,5 +537,4 @@
     rc = rtems_semaphore_delete(diskdevs_mutex);
 
-    /* XXX bdbuf should be released too! */
     disk_io_initialized = 0;
     return rc;
Index: cpukit/libmisc/Makefile.am
===================================================================
--- cpukit/libmisc/Makefile.am	(revision f14a21df691328cefa1464fc5ef13c0584bbfaf3)
+++ cpukit/libmisc/Makefile.am	(revision 0d15414ed6c144f7f7e4ce63476b3eb9b94acceb)
@@ -32,5 +32,5 @@
 
 noinst_LIBRARIES += libdummy.a
-libdummy_a_SOURCES = dummy/dummy.c
+libdummy_a_SOURCES = dummy/dummy.c dummy/dummy-networking.c
 
 ## dumpbuf
Index: cpukit/libmisc/dummy/dummy-networking.c
===================================================================
--- cpukit/libmisc/dummy/dummy-networking.c	(revision 0d15414ed6c144f7f7e4ce63476b3eb9b94acceb)
+++ cpukit/libmisc/dummy/dummy-networking.c	(revision 0d15414ed6c144f7f7e4ce63476b3eb9b94acceb)
@@ -0,0 +1,58 @@
+/*
+ *  Dummy configuration file
+ *
+ *  COPYRIGHT (c) 1989-2008.
+ *  On-Line Applications Research Corporation (OAR).
+ *
+ *  The license and distribution terms for this file may be
+ *  found in the file LICENSE in this distribution or at
+ *  http://www.rtems.com/license/LICENSE.
+ *
+ *  $Id$
+ */
+
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
+
+#include <rtems.h>
+
+/* Loopback Network Configuration */
+#if defined(RTEMS_NETWORKING)
+  #include <rtems/rtems_bsdnet.h>
+  #include <sys/socket.h>
+  #include <netinet/in.h>
+
+  extern int rtems_bsdnet_loopattach(struct rtems_bsdnet_ifconfig *, int);
+
+  static struct rtems_bsdnet_ifconfig loopback_config = {
+      "lo0",                     /* name */
+      rtems_bsdnet_loopattach,   /* attach function */
+      NULL,                      /* link to next interface */
+      "127.0.0.1",               /* IP address */
+      "255.0.0.0",               /* IP net mask */
+      0,                         /* hardware_address */
+      0, 0, 0, 0,
+      0, 0, 0,
+      0
+  };
+
+  struct rtems_bsdnet_config rtems_bsdnet_config = {
+      &loopback_config,       /* Network interface */
+      NULL,                   /* Use fixed network configuration */
+      0,                      /* Default network task priority */
+      0,                      /* Default mbuf capacity */
+      0,                      /* Default mbuf cluster capacity */
+      "testSystem",           /* Host name */
+      "nowhere.com",          /* Domain name */
+      "127.0.0.1",            /* Gateway */
+      "127.0.0.1",            /* Log host */
+      {"127.0.0.1" },         /* Name server(s) */
+      {"127.0.0.1" },         /* NTP server(s) */
+      1,                      /* sb_efficiency */
+      0,                      /* udp_tx_buf_size */
+      0,                      /* udp_rx_buf_size */
+      0,                      /* tcp_tx_buf_size */
+      0                       /* tcp_rx_buf_size */
+  };
+#endif
Index: cpukit/libmisc/dummy/dummy.c
===================================================================
--- cpukit/libmisc/dummy/dummy.c	(revision f14a21df691328cefa1464fc5ef13c0584bbfaf3)
+++ cpukit/libmisc/dummy/dummy.c	(revision 0d15414ed6c144f7f7e4ce63476b3eb9b94acceb)
@@ -37,42 +37,2 @@
 #include <rtems/confdefs.h>
 
-/* Loopback Network Configuration */
-#if defined(RTEMS_NETWORKING)
-  #include <rtems/rtems_bsdnet.h>
-  #include <sys/socket.h>
-  #include <netinet/in.h>
-
-  extern int rtems_bsdnet_loopattach(struct rtems_bsdnet_ifconfig *, int);
-
-  static struct rtems_bsdnet_ifconfig loopback_config = {
-      "lo0",                     /* name */
-      rtems_bsdnet_loopattach,   /* attach function */
-      NULL,                      /* link to next interface */
-      "127.0.0.1",               /* IP address */
-      "255.0.0.0",               /* IP net mask */
-      0,                         /* hardware_address */
-      0, 0, 0, 0,
-      0, 0, 0,
-      0
-  };
-
-  struct rtems_bsdnet_config rtems_bsdnet_config = {
-      &loopback_config,       /* Network interface */
-      NULL,                   /* Use fixed network configuration */
-      0,                      /* Default network task priority */
-      0,                      /* Default mbuf capacity */
-      0,                      /* Default mbuf cluster capacity */
-      "testSystem",           /* Host name */
-      "nowhere.com",          /* Domain name */
-      "127.0.0.1",            /* Gateway */
-      "127.0.0.1",            /* Log host */
-      {"127.0.0.1" },         /* Name server(s) */
-      {"127.0.0.1" },         /* NTP server(s) */
-      1,                      /* sb_efficiency */
-      0,                      /* udp_tx_buf_size */
-      0,                      /* udp_rx_buf_size */
-      0,                      /* tcp_tx_buf_size */
-      0                       /* tcp_rx_buf_size */
-  };
-#endif
-
Index: cpukit/sapi/include/confdefs.h
===================================================================
--- cpukit/sapi/include/confdefs.h	(revision f14a21df691328cefa1464fc5ef13c0584bbfaf3)
+++ cpukit/sapi/include/confdefs.h	(revision 0d15414ed6c144f7f7e4ce63476b3eb9b94acceb)
@@ -728,30 +728,43 @@
                               RTEMS_BDBUF_SWAPOUT_TASK_BLOCK_HOLD_DEFAULT
   #endif
+  #ifndef CONFIGURE_SWAPOUT_WORKER_TASKS
+    #define CONFIGURE_SWAPOUT_WORKER_TASKS \
+                              RTEMS_BDBUF_SWAPOUT_WORKER_TASKS_DEFAULT
+  #endif
+  #ifndef CONFIGURE_SWAPOUT_WORKER_TASK_PRIORITY
+    #define CONFIGURE_SWAPOUT_WORKER_TASK_PRIORITY \
+                              RTEMS_BDBUF_SWAPOUT_WORKER_TASK_PRIORITY_DEFAULT
+  #endif
+  #ifndef CONFIGURE_BDBUF_CACHE_MEMORY_SIZE
+    #define CONFIGURE_BDBUF_CACHE_MEMORY_SIZE \
+                              RTEMS_BDBUF_CACHE_MEMORY_SIZE_DEFAULT
+  #endif
+  #ifndef CONFIGURE_BDBUF_BUFFER_MIN_SIZE
+    #define CONFIGURE_BDBUF_BUFFER_MIN_SIZE \
+                              RTEMS_BDBUF_BUFFER_MIN_SIZE_DEFAULT
+  #endif
+  #ifndef CONFIGURE_BDBUF_BUFFER_MAX_SIZE
+    #define CONFIGURE_BDBUF_BUFFER_MAX_SIZE \
+                              RTEMS_BDBUF_BUFFER_MAX_SIZE_DEFAULT
+  #endif
   #ifdef CONFIGURE_INIT
-    rtems_bdbuf_config rtems_bdbuf_configuration = { 
+    const rtems_bdbuf_config rtems_bdbuf_configuration = { 
       CONFIGURE_BDBUF_MAX_READ_AHEAD_BLOCKS,
       CONFIGURE_BDBUF_MAX_WRITE_BLOCKS,
       CONFIGURE_SWAPOUT_TASK_PRIORITY,
       CONFIGURE_SWAPOUT_SWAP_PERIOD,
-      CONFIGURE_SWAPOUT_BLOCK_HOLD
+      CONFIGURE_SWAPOUT_BLOCK_HOLD,
+      CONFIGURE_SWAPOUT_WORKER_TASKS,
+      CONFIGURE_SWAPOUT_WORKER_TASK_PRIORITY,
+      CONFIGURE_BDBUF_CACHE_MEMORY_SIZE,
+      CONFIGURE_BDBUF_BUFFER_MIN_SIZE,
+      CONFIGURE_BDBUF_BUFFER_MAX_SIZE
     };
   #endif
-  #ifndef CONFIGURE_HAS_OWN_BDBUF_TABLE
-    #ifndef CONFIGURE_BDBUF_BUFFER_COUNT
-      #define CONFIGURE_BDBUF_BUFFER_COUNT 64
-    #endif
-
-    #ifndef CONFIGURE_BDBUF_BUFFER_SIZE
-      #define CONFIGURE_BDBUF_BUFFER_SIZE 512
-    #endif
-    #ifdef CONFIGURE_INIT
-      rtems_bdbuf_pool_config rtems_bdbuf_pool_configuration[] = {
-        {CONFIGURE_BDBUF_BUFFER_SIZE, CONFIGURE_BDBUF_BUFFER_COUNT, NULL}
-      };
-      size_t rtems_bdbuf_pool_configuration_size = 
-        (sizeof(rtems_bdbuf_pool_configuration) /
-         sizeof(rtems_bdbuf_pool_configuration[0]));
-    #endif /* CONFIGURE_INIT */
-  #endif /* CONFIGURE_HAS_OWN_BDBUF_TABLE        */
+  #if defined(CONFIGURE_HAS_OWN_BDBUF_TABLE) || \
+      defined(CONFIGURE_BDBUF_BUFFER_SIZE) || \
+      defined(CONFIGURE_BDBUF_BUFFER_COUNT)
+    #error BDBUF Cache does not use a buffer configuration table. Please remove.
+  #endif
 #endif /* CONFIGURE_APPLICATION_NEEDS_LIBBLOCK */
 
Index: cpukit/sapi/inline/rtems/chain.inl
===================================================================
--- cpukit/sapi/inline/rtems/chain.inl	(revision f14a21df691328cefa1464fc5ef13c0584bbfaf3)
+++ cpukit/sapi/inline/rtems/chain.inl	(revision 0d15414ed6c144f7f7e4ce63476b3eb9b94acceb)
@@ -97,5 +97,5 @@
  *  @param[in] the_chain is the chain to be operated upon.
  *
- *  @return This method returns the permanent head node of the chain.
+ *  @return This method returns the permanent  node of the chain.
  */
 RTEMS_INLINE_ROUTINE rtems_chain_node *rtems_chain_head(
@@ -120,4 +120,54 @@
 {
   return _Chain_Tail( the_chain );
+}
+
+/**
+ *  @brief Return pointer to Chain's First node after the permanent head.
+ *
+ *  This function returns a pointer to the first node on the chain after the
+ *  head.
+ *
+ *  @param[in] the_chain is the chain to be operated upon.
+ *
+ *  @return This method returns the first node of the chain.
+ */
+RTEMS_INLINE_ROUTINE rtems_chain_node *rtems_chain_first(
+  rtems_chain_control *the_chain
+)
+{
+  return _Chain_First( the_chain );
+}
+
+/**
+ *  @brief Return pointer to Chain's Last node before the permanent tail.
+ *
+ *  This function returns a pointer to the last node on the chain just before
+ *  the tail.
+ *
+ *  @param[in] the_chain is the chain to be operated upon.
+ *
+ *  @return This method returns the last node of the chain.
+ */
+RTEMS_INLINE_ROUTINE rtems_chain_node *rtems_chain_last(
+  rtems_chain_control *the_chain
+)
+{
+  return _Chain_Last( the_chain );
+}
+
+/**
+ *  @brief Return pointer the next node from this node
+ *
+ *  This function returns a pointer to the next node after this node.
+ *
+ *  @param[in] the_node is the node to be operated upon.
+ *
+ *  @return This method returns the next node on the chain.
+ */
+RTEMS_INLINE_ROUTINE rtems_chain_node *rtems_chain_next(
+  rtems_chain_node *the_node
+)
+{
+  return _Chain_Next( the_node );
 }
 
Index: cpukit/score/include/rtems/score/object.h
===================================================================
--- cpukit/score/include/rtems/score/object.h	(revision f14a21df691328cefa1464fc5ef13c0584bbfaf3)
+++ cpukit/score/include/rtems/score/object.h	(revision 0d15414ed6c144f7f7e4ce63476b3eb9b94acceb)
@@ -74,18 +74,18 @@
 typedef uint8_t    Objects_Maximum;
 
-#define OBJECTS_INDEX_START_BIT  0
-#define OBJECTS_API_START_BIT    8
-#define OBJECTS_CLASS_START_BIT 11
-
-#define OBJECTS_INDEX_MASK      (Objects_Id)0x00ff
-#define OBJECTS_API_MASK        (Objects_Id)0x0700
-#define OBJECTS_CLASS_MASK      (Objects_Id)0xF800
-
-#define OBJECTS_INDEX_VALID_BITS  (Objects_Id)0x00ff
-#define OBJECTS_API_VALID_BITS    (Objects_Id)0x0007
+#define OBJECTS_INDEX_START_BIT  0U
+#define OBJECTS_API_START_BIT    8U
+#define OBJECTS_CLASS_START_BIT 11U
+
+#define OBJECTS_INDEX_MASK      (Objects_Id)0x00ffU
+#define OBJECTS_API_MASK        (Objects_Id)0x0700U
+#define OBJECTS_CLASS_MASK      (Objects_Id)0xF800U
+
+#define OBJECTS_INDEX_VALID_BITS  (Objects_Id)0x00ffU
+#define OBJECTS_API_VALID_BITS    (Objects_Id)0x0007U
 /* OBJECTS_NODE_VALID_BITS should not be used with 16 bit Ids */
-#define OBJECTS_CLASS_VALID_BITS  (Objects_Id)0x001f
-
-#define OBJECTS_UNLIMITED_OBJECTS 0x8000
+#define OBJECTS_CLASS_VALID_BITS  (Objects_Id)0x001fU
+
+#define OBJECTS_UNLIMITED_OBJECTS 0x8000U
 
 #define OBJECTS_ID_INITIAL_INDEX  (0)
@@ -114,5 +114,5 @@
  *  the object Id.
  */
-#define OBJECTS_INDEX_START_BIT  0
+#define OBJECTS_INDEX_START_BIT  0U
 
 
@@ -121,5 +121,5 @@
  *  the object Id.
  */
-#define OBJECTS_NODE_START_BIT  16
+#define OBJECTS_NODE_START_BIT  16U
 
 /**
@@ -127,5 +127,5 @@
  *  the object Id.
  */
-#define OBJECTS_API_START_BIT   24
+#define OBJECTS_API_START_BIT   24U
 
 /**
@@ -133,25 +133,25 @@
  *  the object Id.
  */
-#define OBJECTS_CLASS_START_BIT 27
+#define OBJECTS_CLASS_START_BIT 27U
 
 /**
  *  This mask is used to extract the index portion of an object Id.
  */
-#define OBJECTS_INDEX_MASK      (Objects_Id)0x0000ffff
+#define OBJECTS_INDEX_MASK      (Objects_Id)0x0000ffffU
 
 /**
  *  This mask is used to extract the node portion of an object Id.
  */
-#define OBJECTS_NODE_MASK       (Objects_Id)0x00ff0000
+#define OBJECTS_NODE_MASK       (Objects_Id)0x00ff0000U
 
 /**
  *  This mask is used to extract the API portion of an object Id.
  */
-#define OBJECTS_API_MASK        (Objects_Id)0x07000000
+#define OBJECTS_API_MASK        (Objects_Id)0x07000000U
 
 /**
  *  This mask is used to extract the class portion of an object Id.
  */
-#define OBJECTS_CLASS_MASK      (Objects_Id)0xf8000000
+#define OBJECTS_CLASS_MASK      (Objects_Id)0xf8000000U
 
 /**
@@ -159,5 +159,5 @@
  *  are set after shifting to extract the index portion of an object Id.
  */
-#define OBJECTS_INDEX_VALID_BITS  (Objects_Id)0x0000ffff
+#define OBJECTS_INDEX_VALID_BITS  (Objects_Id)0x0000ffffU
 
 /**
@@ -165,5 +165,5 @@
  *  are set after shifting to extract the node portion of an object Id.
  */
-#define OBJECTS_NODE_VALID_BITS   (Objects_Id)0x000000ff
+#define OBJECTS_NODE_VALID_BITS   (Objects_Id)0x000000ffU
 
 /**
@@ -171,5 +171,5 @@
  *  are set after shifting to extract the API portion of an object Id.
  */
-#define OBJECTS_API_VALID_BITS    (Objects_Id)0x00000007
+#define OBJECTS_API_VALID_BITS    (Objects_Id)0x00000007U
 
 /**
@@ -177,5 +177,5 @@
  *  are set after shifting to extract the class portion of an object Id.
  */
-#define OBJECTS_CLASS_VALID_BITS  (Objects_Id)0x0000001f
+#define OBJECTS_CLASS_VALID_BITS  (Objects_Id)0x0000001fU
 
 /**
@@ -183,5 +183,5 @@
  *  table when specifying the number of configured objects.
  */
-#define OBJECTS_UNLIMITED_OBJECTS 0x80000000
+#define OBJECTS_UNLIMITED_OBJECTS 0x80000000U
 
 /**
@@ -193,5 +193,5 @@
  *  This is the highest value for the index portion of an object Id.
  */
-#define OBJECTS_ID_FINAL_INDEX    (0xffff)
+#define OBJECTS_ID_FINAL_INDEX    (0xffffU)
 #endif
 
@@ -337,5 +337,5 @@
   bool              auto_extend;
   /** This is the number of objects in a block. */
-  uint32_t          allocation_size;
+  Objects_Maximum   allocation_size;
   /** This is the size in bytes of each object instance. */
   size_t            size;
Index: cpukit/score/inline/rtems/score/chain.inl
===================================================================
--- cpukit/score/inline/rtems/score/chain.inl	(revision f14a21df691328cefa1464fc5ef13c0584bbfaf3)
+++ cpukit/score/inline/rtems/score/chain.inl	(revision 0d15414ed6c144f7f7e4ce63476b3eb9b94acceb)
@@ -84,5 +84,5 @@
 /** @brief Return pointer to Chain Head
  *
- *  This function returns a pointer to the first node on the chain.
+ *  This function returns a pointer to the head node on the chain.
  *
  *  @param[in] the_chain is the chain to be operated upon.
@@ -110,4 +110,66 @@
 {
    return (Chain_Node *) &the_chain->permanent_null;
+}
+
+/** @brief Return pointer to Chain's First node
+ *
+ *  This function returns a pointer to the first node on the chain after the
+ *  head.
+ *
+ *  @param[in] the_chain is the chain to be operated upon.
+ *
+ *  @return This method returns the first node of the chain.
+ */
+RTEMS_INLINE_ROUTINE Chain_Node *_Chain_First(
+  Chain_Control *the_chain
+)
+{
+  return the_chain->first;
+}
+
+/** @brief Return pointer to Chain's Last node
+ *
+ *  This function returns a pointer to the last node on the chain just before
+ *  the tail.
+ *
+ *  @param[in] the_chain is the chain to be operated upon.
+ *
+ *  @return This method returns the last node of the chain.
+ */
+RTEMS_INLINE_ROUTINE Chain_Node *_Chain_Last(
+  Chain_Control *the_chain
+)
+{
+  return the_chain->last;
+}
+
+/** @brief Return pointer the next node from this node
+ *
+ *  This function returns a pointer to the next node after this node.
+ *
+ *  @param[in] the_node is the node to be operated upon.
+ *
+ *  @return This method returns the next node on the chain.
+ */
+RTEMS_INLINE_ROUTINE Chain_Node *_Chain_Next(
+  Chain_Node *the_node
+)
+{
+  return the_node->next;
+}
+
+/** @brief Return pointer the previous node from this node
+ *
+ *  This function returns a pointer to the previous node on this chain.
+ *
+ *  @param[in] the_node is the node to be operated upon.
+ *
+ *  @return This method returns the previous node on the chain.
+ */
+RTEMS_INLINE_ROUTINE Chain_Node *_Chain_Previous(
+  Chain_Node *the_node
+)
+{
+  return the_node->previous;
 }
 
Index: cpukit/score/inline/rtems/score/object.inl
===================================================================
--- cpukit/score/inline/rtems/score/object.inl	(revision f14a21df691328cefa1464fc5ef13c0584bbfaf3)
+++ cpukit/score/inline/rtems/score/object.inl	(revision 0d15414ed6c144f7f7e4ce63476b3eb9b94acceb)
@@ -112,5 +112,7 @@
 )
 {
-  return (id >> OBJECTS_INDEX_START_BIT) & OBJECTS_INDEX_VALID_BITS;
+  return
+    (Objects_Maximum)((id >> OBJECTS_INDEX_START_BIT) &
+                                          OBJECTS_INDEX_VALID_BITS);
 }
 
@@ -225,5 +227,5 @@
 RTEMS_INLINE_ROUTINE void _Objects_Set_local_object(
   Objects_Information *information,
-  uint16_t             index,
+  uint32_t             index,
   Objects_Control     *the_object
 )
